import { Component, ComponentID } from '@teambit/component';
import { Graph, Node, Edge } from '@teambit/graph.cleargraph';
import { Dependency } from '../model/dependency';
import { DuplicateDependency } from '../duplicate-dependency';
export declare const DEPENDENCIES_TYPES: string[];
type ComponentNode = Node<Component>;
type DependencyEdge = Edge<Dependency>;
export declare class ComponentGraph extends Graph<Component, Dependency> {
    seederIds: ComponentID[];
    constructor(nodes?: ComponentNode[], edges?: DependencyEdge[]);
    protected create(nodes?: ComponentNode[], edges?: DependencyEdge[]): this;
    /**
     * @deprecate use graph.getGraphIds().findCycles()
     */
    findCycles(graph?: this): string[][];
    findDuplicateDependencies(): Map<string, DuplicateDependency>;
    buildFromCleargraph(graph: Graph<Component, Dependency>): ComponentGraph;
    runtimeOnly(componentIds: string[]): this;
    private shouldLimitToSeedersOnly;
    private calculateVersionMap;
}
export {};
