import { Command, CommandOptions } from '@teambit/cli';
import { ComponentMain } from '@teambit/component';
import { GraphMain } from './graph.main.runtime';
export type GraphOpt = {
    remote?: string;
    layout?: string;
    cycles?: boolean;
    png?: boolean;
    json?: boolean;
    includeLocalOnly?: boolean;
    includeDependencies?: boolean;
};
export declare class GraphCmd implements Command {
    private componentAspect;
    private graph;
    name: string;
    description: string;
    extendedDescription: 'black arrow is a runtime dependency. red arrow is either dev or peer';
    group: string;
    alias: string;
    options: CommandOptions;
    remoteOp: boolean;
    constructor(componentAspect: ComponentMain, graph: GraphMain);
    report([id]: [string], graphOpts: GraphOpt): Promise<string>;
    json([id]: [string], graphOpts: GraphOpt): Promise<any>;
    private getWorkspaceIfExist;
    private generateGraphFromRemote;
}
