import { CLIMain } from '@teambit/cli';
import { ComponentMain, ComponentID } from '@teambit/component';
import { GraphqlMain } from '@teambit/graphql';
import { Logger, LoggerMain } from '@teambit/logger';
import { GetGraphOpts } from './graph-builder';
import { GraphOpt } from './graph-cmd';
import { ComponentGraph } from './component-graph';
import { ComponentIdGraph } from './component-id-graph';
import { VisualDependencyGraph } from '@teambit/legacy.dependency-graph';
export declare class GraphMain {
    private componentAspect;
    private logger;
    constructor(componentAspect: ComponentMain, logger: Logger);
    /**
     * important - prefer using `getGraphIds()` it's way better in terms of performance.
     */
    getGraph(ids?: ComponentID[], opts?: GetGraphOpts): Promise<ComponentGraph>;
    getGraphIds(ids?: ComponentID[], opts?: GetGraphOpts): Promise<ComponentIdGraph>;
    /**
     * this visual graph-ids can render the graph as a SVG/png and other formats.
     */
    getVisualGraphIds(ids?: ComponentID[], opts?: GraphOpt): Promise<VisualDependencyGraph>;
    private getVisualCyclesFromGraph;
    private getIdsWithVersions;
    static slots: never[];
    static dependencies: import("@teambit/harmony").Aspect[];
    static runtime: import("@teambit/harmony").RuntimeDefinition;
    static provider([graphql, componentAspect, cli, loggerMain]: [
        GraphqlMain,
        ComponentMain,
        CLIMain,
        LoggerMain
    ]): Promise<GraphMain>;
}
