import { ComponentType } from 'react';
import { SlotRegistry } from '@teambit/harmony';
import { ComponentCompareUI } from '@teambit/component-compare';
import { ComponentUI, ComponentModel } from '@teambit/component';
import { DependenciesGraph } from './ui/dependencies-graph';
export interface ComponentWidgetProps extends React.HTMLAttributes<HTMLDivElement> {
    component: ComponentModel;
}
export type ComponentWidget = ComponentType<ComponentWidgetProps>;
export type ComponentWidgetSlot = SlotRegistry<ComponentWidget>;
export type GraphUIConfig = {
    componentTab: boolean;
};
/**
 * Presents dependencies graph in the component page
 */
export declare class GraphUI {
    private componentWidgetSlot;
    getDependenciesGraph(): typeof DependenciesGraph;
    /**
     * adds plugins to component nodes
     * @param value
     */
    registerComponentWidget(value: ComponentWidget): void;
    constructor(componentWidgetSlot: ComponentWidgetSlot);
    static dependencies: import("@teambit/harmony").Aspect[];
    static runtime: import("@teambit/harmony").RuntimeDefinition;
    static slots: ((registerFn: () => string) => SlotRegistry<ComponentWidget>)[];
    static defaultConfig: {
        componentTab: boolean;
    };
    static provider([componentUI, componentCompare]: [ComponentUI, ComponentCompareUI], config: GraphUIConfig, [componentWidgetSlot]: [ComponentWidgetSlot]): Promise<GraphUI>;
}
