"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GraphUI = void 0;
function _ui() {
  const data = require("@teambit/ui");
  _ui = function () {
    return data;
  };
  return data;
}
function _harmony() {
  const data = require("@teambit/harmony");
  _harmony = function () {
    return data;
  };
  return data;
}
function _componentCompare() {
  const data = require("@teambit/component-compare");
  _componentCompare = function () {
    return data;
  };
  return data;
}
function _component() {
  const data = require("@teambit/component");
  _component = function () {
    return data;
  };
  return data;
}
function _graph() {
  const data = require("./graph.aspect");
  _graph = function () {
    return data;
  };
  return data;
}
function _graph2() {
  const data = require("./ui/graph.section");
  _graph2 = function () {
    return data;
  };
  return data;
}
function _graphCompare() {
  const data = require("./graph.compare.section");
  _graphCompare = function () {
    return data;
  };
  return data;
}
function _dependenciesGraph() {
  const data = require("./ui/dependencies-graph");
  _dependenciesGraph = function () {
    return data;
  };
  return data;
}
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Presents dependencies graph in the component page
 */
class GraphUI {
  getDependenciesGraph() {
    return _dependenciesGraph().DependenciesGraph;
  }

  /**
   * adds plugins to component nodes
   * @param value
   */
  registerComponentWidget(value) {
    this.componentWidgetSlot.register(value);
  }
  constructor(componentWidgetSlot) {
    this.componentWidgetSlot = componentWidgetSlot;
  }
  static async provider([componentUI, componentCompare], config, [componentWidgetSlot]) {
    const graphUI = new GraphUI(componentWidgetSlot);
    const section = new (_graph2().GraphSection)(componentWidgetSlot);
    const graphSection = new (_graphCompare().GraphCompareSection)();
    if (config.componentTab) componentUI.registerNavigation(section.navigationLink, section.order);
    componentUI.registerRoute(section.route);
    componentCompare.registerNavigation(graphSection);
    componentCompare.registerRoutes([graphSection.route]);
    return graphUI;
  }
}
exports.GraphUI = GraphUI;
_defineProperty(GraphUI, "dependencies", [_component().ComponentAspect, _componentCompare().ComponentCompareAspect]);
_defineProperty(GraphUI, "runtime", _ui().UIRuntime);
_defineProperty(GraphUI, "slots", [_harmony().Slot.withType()]);
_defineProperty(GraphUI, "defaultConfig", {
  componentTab: true
});
_graph().GraphAspect.addRuntime(GraphUI);

//# sourceMappingURL=graph.ui.runtime.js.map