"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ComponentNode = ComponentNode;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _classnames() {
  const data = _interopRequireDefault(require("classnames"));
  _classnames = function () {
    return data;
  };
  return data;
}
function _baseUiText() {
  const data = require("@teambit/base-ui.text.muted-text");
  _baseUiText = function () {
    return data;
  };
  return data;
}
function _componentUi() {
  const data = require("@teambit/component.ui.deprecation-icon");
  _componentUi = function () {
    return data;
  };
  return data;
}
function _envsUi() {
  const data = require("@teambit/envs.ui.env-icon");
  _envsUi = function () {
    return data;
  };
  return data;
}
function _designUiStyles() {
  const data = require("@teambit/design.ui.styles.ellipsis");
  _designUiStyles = function () {
    return data;
  };
  return data;
}
function _baseUiSurfaces() {
  const data = require("@teambit/base-ui.surfaces.card");
  _baseUiSurfaces = function () {
    return data;
  };
  return data;
}
function _baseUiRouting() {
  const data = require("@teambit/base-ui.routing.nav-link");
  _baseUiRouting = function () {
    return data;
  };
  return data;
}
function _componentModules() {
  const data = require("@teambit/component.modules.component-url");
  _componentModules = function () {
    return data;
  };
  return data;
}
function _dependenciesGraph() {
  const data = require("../dependencies-graph/");
  _dependenciesGraph = function () {
    return data;
  };
  return data;
}
function _componentNodeModule() {
  const data = _interopRequireDefault(require("./component-node.module.scss"));
  _componentNodeModule = function () {
    return data;
  };
  return data;
}
function _variantsModule() {
  const data = _interopRequireDefault(require("./variants.module.scss"));
  _variantsModule = function () {
    return data;
  };
  return data;
}
const _excluded = ["node", "type"],
  _excluded2 = ["componentId", "className"]; // keep order: styles, then variants
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function ComponentNode(_ref) {
  let {
      node,
      type = 'defaultNode'
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  const graphContext = (0, _react().useContext)(_dependenciesGraph().ComponentGraphContext);
  const {
    component,
    componentId
  } = node;
  const id = component?.id || componentId;
  return /*#__PURE__*/_react().default.createElement(_baseUiSurfaces().Card, _extends({
    className: (0, _classnames().default)(_componentNodeModule().default.compNode, _variantsModule().default[type]),
    elevation: "none"
  }, rest), /*#__PURE__*/_react().default.createElement("div", {
    className: _componentNodeModule().default.firstRow
  }, component && /*#__PURE__*/_react().default.createElement(_envsUi().EnvIcon, {
    component: component,
    className: _componentNodeModule().default.envIcon
  }), /*#__PURE__*/_react().default.createElement(Breadcrumbs, {
    componentId: id,
    className: _baseUiText().mutedText
  })), /*#__PURE__*/_react().default.createElement("div", {
    className: _componentNodeModule().default.nameLine
  }, /*#__PURE__*/_react().default.createElement(_baseUiRouting().NavLink, {
    className: _componentNodeModule().default.link,
    external: true,
    href: _componentModules().ComponentUrl.toUrl(id, {
      includeVersion: false
    })
  }, /*#__PURE__*/_react().default.createElement("span", {
    className: (0, _classnames().default)(_componentNodeModule().default.name, _designUiStyles().ellipsis)
  }, id.name)), id.version && /*#__PURE__*/_react().default.createElement("span", {
    className: (0, _classnames().default)(_componentNodeModule().default.version, _designUiStyles().ellipsis)
  }, id.version), /*#__PURE__*/_react().default.createElement("div", {
    className: _componentNodeModule().default.buffs
  }, component && /*#__PURE__*/_react().default.createElement(_componentUi().DeprecationIcon, {
    component: component
  }), component && graphContext && graphContext.componentWidgets.toArray().map(([widgetId, Widget]) => /*#__PURE__*/_react().default.createElement(Widget, {
    key: widgetId,
    component: component
  })))));
}
function Breadcrumbs(_ref2) {
  let {
      componentId,
      className
    } = _ref2,
    rest = _objectWithoutProperties(_ref2, _excluded2);
  const {
    scope,
    namespace
  } = componentId;
  const showSep = !!scope && !!namespace;
  return /*#__PURE__*/_react().default.createElement("div", _extends({}, rest, {
    className: (0, _classnames().default)(_componentNodeModule().default.breadcrumbs, _designUiStyles().ellipsis, className)
  }), scope, showSep && '/', namespace);
}

//# sourceMappingURL=component-node.js.map