"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DependenciesCompare = DependenciesCompare;
function _classnames() {
  const data = _interopRequireDefault(require("classnames"));
  _classnames = function () {
    return data;
  };
  return data;
}
function _designUi() {
  const data = require("@teambit/design.ui.round-loader");
  _designUi = function () {
    return data;
  };
  return data;
}
function _componentUiComponentCompare() {
  const data = require("@teambit/component.ui.component-compare.context");
  _componentUiComponentCompare = function () {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _reactflow() {
  const data = _interopRequireWildcard(require("reactflow"));
  _reactflow = function () {
    return data;
  };
  return data;
}
function _query() {
  const data = require("../query");
  _query = function () {
    return data;
  };
  return data;
}
function _graphPage() {
  const data = require("../graph-page");
  _graphPage = function () {
    return data;
  };
  return data;
}
function _dependenciesGraph() {
  const data = require("../dependencies-graph");
  _dependenciesGraph = function () {
    return data;
  };
  return data;
}
function _dependenciesCompareModule() {
  const data = _interopRequireDefault(require("./dependencies-compare.module.scss"));
  _dependenciesCompareModule = function () {
    return data;
  };
  return data;
}
function _dependencyCompareNode() {
  const data = require("./dependency-compare-node");
  _dependencyCompareNode = function () {
    return data;
  };
  return data;
}
function _diffGraph() {
  const data = require("./diff-graph");
  _diffGraph = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function ComponentNodeContainer(props) {
  const {
    sourcePosition = _reactflow().Position.Top,
    targetPosition = _reactflow().Position.Bottom,
    data,
    id
  } = props;
  const ReactFlowHandle = _reactflow().Handle;
  return /*#__PURE__*/_react().default.createElement("div", {
    key: id
  }, /*#__PURE__*/_react().default.createElement(ReactFlowHandle, {
    type: "target",
    position: targetPosition,
    isConnectable: false
  }), /*#__PURE__*/_react().default.createElement(ReactFlowHandle, {
    type: "source",
    position: sourcePosition,
    isConnectable: false
  }), /*#__PURE__*/_react().default.createElement(_dependencyCompareNode().DependencyCompareNode, {
    node: data.node,
    type: data.type
  }));
}
function DependenciesCompare() {
  const nodeTypes = _react().default.useMemo(() => ({
    ComponentNode: ComponentNodeContainer
  }), []);
  const graphRef = (0, _react().useRef)();
  const componentCompare = (0, _componentUiComponentCompare().useComponentCompare)();
  const baseId = componentCompare?.base?.model.id;
  const compareId = componentCompare?.compare?.model.id;
  const [filter, setFilter] = (0, _react().useState)('runtimeOnly');
  const isFiltered = filter === 'runtimeOnly';
  const {
    loading: baseLoading,
    graph: baseGraph
  } = (0, _query().useGraphQuery)(baseId && [baseId.toString()], filter);
  const {
    loading: compareLoading,
    graph: compareGraph
  } = (0, _query().useGraphQuery)(compareId && [compareId.toString()], filter);
  const loading = baseLoading || compareLoading;
  const graph = (0, _diffGraph().diffGraph)(baseGraph, compareGraph, baseId) ?? undefined;
  const elements = (0, _dependenciesGraph().calcElements)(graph, {
    rootNode: baseId
  });
  (0, _react().useEffect)(() => () => graphRef.current = undefined, []);
  (0, _react().useEffect)(() => {
    setTimeout(() => {
      if (graph && graph.nodes.length <= 3) return graphRef.current?.fitView({
        padding: 2
      });
      return graphRef.current?.fitView();
    }, 0);
  }, [graph]);
  const handleLoad = (0, _react().useCallback)(instance => {
    graphRef.current = instance;
    if ((graph?.nodes.length ?? 0) <= 3) {
      graphRef.current?.fitView({
        padding: 2,
        maxZoom: 1
      });
    } else {
      instance.fitView({
        maxZoom: 1
      });
    }
  }, [graph?.nodes.length]);
  (0, _react().useEffect)(() => {
    setTimeout(() => {
      if ((graph?.nodes.length ?? 0) <= 3) return graphRef.current?.fitView({
        padding: 2
      });
      return graphRef.current?.fitView();
    }, 0);
  }, [compareId?.toString(), baseId?.toString()]);
  const onCheckFilter = _isFiltered => {
    setFilter(_isFiltered ? 'runtimeOnly' : undefined);
  };
  if (!loading && !graph) {
    return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null);
  }
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)([_dependenciesCompareModule().default.page, _graphPage().styles.graph])
  }, loading && /*#__PURE__*/_react().default.createElement("div", {
    className: _dependenciesCompareModule().default.loader
  }, /*#__PURE__*/_react().default.createElement(_designUi().RoundLoader, null)), !loading && /*#__PURE__*/_react().default.createElement(_reactflow().ReactFlowProvider, null, /*#__PURE__*/_react().default.createElement(_reactflow().default, {
    draggable: false,
    nodesDraggable: true,
    selectNodesOnDrag: false,
    nodesConnectable: false,
    zoomOnDoubleClick: false,
    elementsSelectable: false,
    maxZoom: 100,
    minZoom: 0,
    className: _dependenciesGraph().styles.graph,
    defaultNodes: elements.nodes,
    defaultEdges: elements.edges,
    nodeTypes: nodeTypes,
    onInit: handleLoad,
    proOptions: {
      hideAttribution: true
    }
  }, /*#__PURE__*/_react().default.createElement(_reactflow().Background, null), /*#__PURE__*/_react().default.createElement(_reactflow().Controls, {
    className: _dependenciesGraph().styles.controls
  }), /*#__PURE__*/_react().default.createElement(_reactflow().MiniMap, {
    nodeColor: _dependenciesGraph().calcMinimapColors,
    className: _dependenciesGraph().styles.minimap
  }), /*#__PURE__*/_react().default.createElement(_graphPage().GraphFilters, {
    className: _graphPage().styles.filters,
    disable: loading,
    isFiltered: isFiltered,
    onChangeFilter: onCheckFilter
  }))));
}

//# sourceMappingURL=dependencies-compare.js.map