"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DependencyCompareNode = DependencyCompareNode;
function _baseUiRouting() {
  const data = require("@teambit/base-ui.routing.nav-link");
  _baseUiRouting = function () {
    return data;
  };
  return data;
}
function _baseUiSurfaces() {
  const data = require("@teambit/base-ui.surfaces.card");
  _baseUiSurfaces = function () {
    return data;
  };
  return data;
}
function _baseUiText() {
  const data = require("@teambit/base-ui.text.muted-text");
  _baseUiText = function () {
    return data;
  };
  return data;
}
function _component() {
  const data = require("@teambit/component");
  _component = function () {
    return data;
  };
  return data;
}
function _componentModules() {
  const data = require("@teambit/component.modules.component-url");
  _componentModules = function () {
    return data;
  };
  return data;
}
function _componentUiComponentCompare() {
  const data = require("@teambit/component.ui.component-compare.status-resolver");
  _componentUiComponentCompare = function () {
    return data;
  };
  return data;
}
function _componentUi() {
  const data = require("@teambit/component.ui.deprecation-icon");
  _componentUi = function () {
    return data;
  };
  return data;
}
function _designUiStyles() {
  const data = require("@teambit/design.ui.styles.ellipsis");
  _designUiStyles = function () {
    return data;
  };
  return data;
}
function _envsUi() {
  const data = require("@teambit/envs.ui.env-icon");
  _envsUi = function () {
    return data;
  };
  return data;
}
function _classnames() {
  const data = _interopRequireDefault(require("classnames"));
  _classnames = function () {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _semver() {
  const data = require("semver");
  _semver = function () {
    return data;
  };
  return data;
}
function _variants() {
  const data = require("../../ui/component-node/variants");
  _variants = function () {
    return data;
  };
  return data;
}
function _componentNode() {
  const data = require("../../ui/component-node");
  _componentNode = function () {
    return data;
  };
  return data;
}
function _dependencyCompareNodeModule() {
  const data = _interopRequireDefault(require("./dependency-compare-node.module.scss"));
  _dependencyCompareNodeModule = function () {
    return data;
  };
  return data;
}
function _dependencyCompareVariantsModule() {
  const data = _interopRequireDefault(require("./dependency-compare-variants.module.scss"));
  _dependencyCompareVariantsModule = function () {
    return data;
  };
  return data;
}
const _excluded = ["componentId", "className"];
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function getVariant(nodeType) {
  switch (nodeType) {
    case 'defaultNode':
      return _variants().defaultNode;
    case 'root':
      return _dependencyCompareVariantsModule().default[nodeType];
    case 'external':
      return _variants().external;
    default:
      return null;
  }
}
function DependencyCompareNode(props) {
  const {
    node,
    type = 'defaultNode'
  } = props;
  const {
    id: baseIdStr,
    component: baseComponent,
    compareVersion,
    status,
    componentId
  } = node;
  const {
    version: baseVersion
  } = baseComponent || {
    version: componentId.version
  };
  const baseId = _component().ComponentID.fromString(baseIdStr);
  const versionDiff = (0, _react().useMemo)(() => (0, _semver().valid)(baseVersion) && (0, _semver().valid)(compareVersion) && (0, _semver().compare)(baseVersion, compareVersion), [baseVersion, compareVersion]);
  return /*#__PURE__*/_react().default.createElement(_baseUiSurfaces().Card, {
    className: (0, _classnames().default)(_componentNode().styles.compNode, getVariant(type)),
    elevation: "none"
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: _componentNode().styles.firstRow
  }, baseComponent && /*#__PURE__*/_react().default.createElement(_envsUi().EnvIcon, {
    component: baseComponent,
    className: _componentNode().styles.envIcon
  }), /*#__PURE__*/_react().default.createElement(Breadcrumbs, {
    componentId: baseId,
    className: _baseUiText().mutedText
  })), /*#__PURE__*/_react().default.createElement("div", {
    className: _componentNode().styles.nameLine
  }, /*#__PURE__*/_react().default.createElement(_baseUiRouting().NavLink, {
    className: _dependencyCompareNodeModule().default.link,
    external: true,
    href: _componentModules().ComponentUrl.toUrl(baseId, {
      includeVersion: false
    })
  }, /*#__PURE__*/_react().default.createElement("span", {
    className: (0, _classnames().default)(_componentNode().styles.name, _designUiStyles().ellipsis)
  }, baseId.name)), baseId.version && /*#__PURE__*/_react().default.createElement("span", {
    className: (0, _classnames().default)(_componentNode().styles.version, _designUiStyles().ellipsis)
  }, baseId.version), versionDiff !== 0 && /*#__PURE__*/_react().default.createElement("img", {
    className: (0, _classnames().default)([_dependencyCompareNodeModule().default.arrowIcon, _dependencyCompareNodeModule().default.versionUp]),
    src: "https://static.bit.dev/bit-icons/version-bump.svg"
  }), compareVersion && versionDiff !== 0 && /*#__PURE__*/_react().default.createElement("span", {
    className: (0, _classnames().default)(_dependencyCompareNodeModule().default.version, _componentNode().styles.version, _designUiStyles().ellipsis, versionDiff === -1 && _dependencyCompareNodeModule().default.versionUp, versionDiff === 1 && _dependencyCompareNodeModule().default.versionDown)
  }, compareVersion), /*#__PURE__*/_react().default.createElement("div", {
    className: _dependencyCompareNodeModule().default.buffs
  }, baseComponent && /*#__PURE__*/_react().default.createElement(_componentUi().DeprecationIcon, {
    component: baseComponent
  }), status !== undefined && /*#__PURE__*/_react().default.createElement(_componentUiComponentCompare().CompareStatusResolver, {
    status: status
  }))));
}
function Breadcrumbs(_ref) {
  let {
      componentId,
      className
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  const {
    scope,
    namespace
  } = componentId;
  const showSep = !!scope && !!namespace;
  return /*#__PURE__*/_react().default.createElement("div", _extends({}, rest, {
    className: (0, _classnames().default)(_dependencyCompareNodeModule().default.breadcrumbs, _designUiStyles().ellipsis, className)
  }), scope, showSep && '/', namespace);
}

//# sourceMappingURL=dependency-compare-node.js.map