"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.calcLayout = calcLayout;
function _dagre() {
  const data = _interopRequireWildcard(require("@dagrejs/dagre"));
  _dagre = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
const NODE_WIDTH = 260;
const NODE_HEIGHT = 90;
const TOP_TO_BOTTOM = 'TB';

/**
 * calculate the specific location of each node in the graph
 */
function calcLayout(graph) {
  const g = new (_dagre().graphlib.Graph)();
  g.setGraph({
    rankdir: TOP_TO_BOTTOM,
    nodesep: 25,
    ranksep: 100,
    edgesep: 100,
    ranker: 'longest-path',
    acyclicer: 'greedy'
  });
  g.setDefaultEdgeLabel(() => ({}));

  // make a new instance of { width, height } per node, or dagre will get confused and place all nodes in the same spot
  graph.nodes.forEach(n => g.setNode(n.id, _objectSpread(_objectSpread({}, n), {}, {
    width: NODE_WIDTH,
    height: NODE_HEIGHT
  })));
  graph.edges.forEach(e => g.setEdge(e.sourceId, e.targetId));

  // position items in graph
  _dagre().default.layout(g);
  const positionsArr = g.nodes().map(nodeId => {
    const node = g.node(nodeId);
    const pos = {
      x: node.x - node.width / 2,
      y: node.y - node.height / 2
    };
    return [nodeId, pos];
  });
  return new Map(positionsArr);
}

//# sourceMappingURL=calc-layout.js.map