"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.depTypeToClass = depTypeToClass;
exports.depTypeToLabel = depTypeToLabel;
function _edgeType() {
  const data = require("../../../edge-type");
  _edgeType = function () {
    return data;
  };
  return data;
}
function _edgeModule() {
  const data = _interopRequireDefault(require("./edge.module.scss"));
  _edgeModule = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function depTypeToClass(depType) {
  switch (depType) {
    case 'DEV':
      return _edgeModule().default.dev;
    case 'PEER':
      return _edgeModule().default.peer;
    case 'RUNTIME':
      return _edgeModule().default.runtime;
    default:
      return undefined;
  }
}
function depTypeToLabel(type) {
  switch (type) {
    case _edgeType().EdgeType.peer:
      return 'Peer Dependency';
    case _edgeType().EdgeType.dev:
      return 'Development Dependency';
    case _edgeType().EdgeType.runtime:
      return 'Dependency';
    default:
      return type.toLowerCase();
  }
}

//# sourceMappingURL=dep-edge.js.map