"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DependenciesGraph = DependenciesGraph;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _classnames() {
  const data = _interopRequireDefault(require("classnames"));
  _classnames = function () {
    return data;
  };
  return data;
}
function _reactflow() {
  const data = _interopRequireWildcard(require("reactflow"));
  _reactflow = function () {
    return data;
  };
  return data;
}
function _componentNode() {
  const data = require("../component-node");
  _componentNode = function () {
    return data;
  };
  return data;
}
function _calcElements() {
  const data = require("./calc-elements");
  _calcElements = function () {
    return data;
  };
  return data;
}
function _minimap() {
  const data = require("./minimap");
  _minimap = function () {
    return data;
  };
  return data;
}
function _graphContext() {
  const data = require("./graph-context");
  _graphContext = function () {
    return data;
  };
  return data;
}
require("reactflow/dist/style.css");
function _dependenciesGraphModule() {
  const data = _interopRequireDefault(require("./dependencies-graph.module.scss"));
  _dependenciesGraphModule = function () {
    return data;
  };
  return data;
}
const _excluded = ["graph", "rootNode", "componentWidgets", "className", "onLoad", "children", "loadingGraphMetadata"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function ComponentNodeContainer(props) {
  const {
    sourcePosition = _reactflow().Position.Top,
    targetPosition = _reactflow().Position.Bottom,
    data,
    id
  } = props;
  const ReactFlowHandle = _reactflow().Handle;
  return /*#__PURE__*/_react().default.createElement("div", {
    key: id
  }, /*#__PURE__*/_react().default.createElement(ReactFlowHandle, {
    type: "target",
    position: targetPosition,
    isConnectable: false
  }), /*#__PURE__*/_react().default.createElement(ReactFlowHandle, {
    type: "source",
    position: sourcePosition,
    isConnectable: false
  }), /*#__PURE__*/_react().default.createElement(_componentNode().ComponentNode, {
    node: data.node,
    type: data.type
  }));
}
function DependenciesGraph(_ref) {
  let {
      graph,
      rootNode,
      componentWidgets,
      className,
      onLoad,
      children,
      loadingGraphMetadata
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  const nodeTypes = _react().default.useMemo(() => ({
    ComponentNode: ComponentNodeContainer
  }), []);
  const graphRef = (0, _react().useRef)();
  const elements = (0, _calcElements().calcElements)(graph, {
    rootNode
  });
  const [nodes, setNodes] = (0, _reactflow().useNodesState)(elements.nodes);
  (0, _react().useEffect)(() => {
    setNodes(elements.nodes);
  }, [elements.nodes]);
  const context = (0, _react().useMemo)(() => ({
    componentWidgets,
    loadingGraphMetadata
  }), [componentWidgets, loadingGraphMetadata]);
  const handleLoad = (0, _react().useCallback)(instance => {
    graphRef.current = instance;
    if ((elements?.nodes.length ?? 0) <= 3) {
      instance.fitView({
        padding: 2,
        maxZoom: 1
      });
    } else {
      instance.fitView({
        maxZoom: 1
      });
    }
    onLoad?.(instance);
  }, [onLoad]);

  // clear ref on unmount
  (0, _react().useEffect)(() => () => graphRef.current = undefined, []);
  (0, _react().useEffect)(() => {
    setTimeout(() => {
      if (!elements?.nodes.length) return;
      if ((elements?.nodes?.length ?? 0) <= 3) {
        return graphRef.current?.fitView({
          padding: 2,
          maxZoom: 1
        });
      }
      return graphRef.current?.fitView({
        maxZoom: 1
      });
    }, 100);
  }, [elements?.nodes.length]);
  return /*#__PURE__*/_react().default.createElement(_graphContext().ComponentGraphContext.Provider, {
    value: context
  }, /*#__PURE__*/_react().default.createElement(_reactflow().ReactFlowProvider, null, /*#__PURE__*/_react().default.createElement(_reactflow().default, _extends({
    draggable: false,
    nodesDraggable: true,
    selectNodesOnDrag: false,
    nodesConnectable: false,
    zoomOnDoubleClick: false,
    elementsSelectable: false,
    maxZoom: 100,
    minZoom: 0
  }, rest, {
    className: (0, _classnames().default)(_dependenciesGraphModule().default.graph, className),
    nodes: nodes,
    edges: elements.edges,
    nodeTypes: nodeTypes,
    onInit: handleLoad,
    fitView: true,
    fitViewOptions: {
      padding: (elements?.nodes.length ?? 0) <= 3 ? 2 : undefined,
      maxZoom: 1
    },
    proOptions: {
      hideAttribution: true
    }
  }), /*#__PURE__*/_react().default.createElement(_reactflow().Background, null), /*#__PURE__*/_react().default.createElement(_reactflow().Controls, {
    className: _dependenciesGraphModule().default.controls
  }), /*#__PURE__*/_react().default.createElement(_reactflow().MiniMap, {
    nodeColor: _minimap().calcMinimapColors,
    className: _dependenciesGraphModule().default.minimap
  }), children)));
}

//# sourceMappingURL=dependencies-graph.js.map