"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GraphPage = GraphPage;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _designUiPages() {
  const data = require("@teambit/design.ui.pages.not-found");
  _designUiPages = function () {
    return data;
  };
  return data;
}
function _designUiPages2() {
  const data = require("@teambit/design.ui.pages.server-error");
  _designUiPages2 = function () {
    return data;
  };
  return data;
}
function _component() {
  const data = require("@teambit/component");
  _component = function () {
    return data;
  };
  return data;
}
function _designSkeletons() {
  const data = require("@teambit/design.skeletons.base-skeleton");
  _designSkeletons = function () {
    return data;
  };
  return data;
}
function _classnames() {
  const data = _interopRequireDefault(require("classnames"));
  _classnames = function () {
    return data;
  };
  return data;
}
function _query() {
  const data = require("../query");
  _query = function () {
    return data;
  };
  return data;
}
function _dependenciesGraph() {
  const data = require("../dependencies-graph");
  _dependenciesGraph = function () {
    return data;
  };
  return data;
}
function _graphFilters() {
  const data = require("./graph-filters");
  _graphFilters = function () {
    return data;
  };
  return data;
}
function _graphPageModule() {
  const data = _interopRequireDefault(require("./graph-page.module.scss"));
  _graphPageModule = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function GraphPage({
  componentWidgets
}) {
  const component = (0, _react().useContext)(_component().ComponentContext);
  const [filter, setFilter] = (0, _react().useState)('runtimeOnly');
  const onCheckFilter = isFiltered => {
    setFilter(isFiltered ? 'runtimeOnly' : undefined);
  };
  const {
    graph,
    error,
    graphLoading,
    loading
  } = (0, _query().useGraphQuery)([component.id.toString()], filter);
  const isFiltered = filter === 'runtimeOnly';
  if (error) return error.code === 404 ? /*#__PURE__*/_react().default.createElement(_designUiPages().NotFoundPage, null) : /*#__PURE__*/_react().default.createElement(_designUiPages2().ServerErrorPage, null);
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(_graphPageModule().default.page)
  }, /*#__PURE__*/_react().default.createElement(_dependenciesGraph().DependenciesGraph, {
    componentWidgets: componentWidgets,
    graph: graph,
    rootNode: component.id,
    className: (0, _classnames().default)(_graphPageModule().default.graph, !graph && _designSkeletons().skeleton),
    loadingGraphMetadata: graphLoading
  }, graph && /*#__PURE__*/_react().default.createElement(_graphFilters().GraphFilters, {
    className: (0, _classnames().default)(_graphPageModule().default.filters),
    disable: loading,
    isFiltered: isFiltered,
    onChangeFilter: onCheckFilter
  })));
}

//# sourceMappingURL=graph-page.js.map